<template>
    <div>
        <v-row>
            <v-col>
                <data-table
                    v-model="items"
                    endpoint="api/warehouses"
                    :title="$t('warehouse')"
                    :headers="headers"
                    :search-label="searchLabel"
                >
                    <template v-slot:buttons>
                        <v-btn
                            color="primary"
                            to="/warehouse/create"
                        >
                            <v-icon class="medium" color="white" left>mdi-plus</v-icon>
                            {{ $t('warehouse') }}
                        </v-btn>
                    </template>

                    <template v-slot:item="{ item, index }">
                        <tr>
                            <td>{{ item.country }}</td>
                            <td>{{ item.name }}</td>
                            <td>{{ item.city }}</td>
                            <td>{{ item.phone }}</td>
                            <td>{{ item.fax }}</td>
                            <td>
                                <v-chip
                                    :color="item.enabled ? 'success' : 'error'"
                                    text-color="white"
                                    label
                                >
                                    {{ item.enabled ? $t('enabled') : $t('disabled') }}
                                </v-chip>
                            </td>
                            <td>
                                <v-menu
                                    :close-on-content-click="false"
                                    offset-y
                                    bottom
                                >
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn
                                            color="primary"
                                            dark
                                            icon
                                            v-bind="attrs"
                                            v-on="on"
                                        >
                                            <v-icon>mdi-dots-horizontal</v-icon>
                                        </v-btn>
                                    </template>

                                    <v-list dense>
                                        <v-list-item>
                                            <v-btn
                                                @click="edit(item)"
                                                class="text-capitalize"
                                                color="primary"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-pencil</v-icon>
                                                {{ $t('edit') }}
                                            </v-btn>
                                        </v-list-item>
                                        <v-divider class="my-2"></v-divider>
                                        <v-list-item>
                                            <v-btn
                                                @click="openDeleteDialog(item)"
                                                class="text-capitalize"
                                                color="error"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-delete</v-icon>
                                                {{ $t('delete') }}
                                            </v-btn>
                                        </v-list-item>
                                    </v-list>
                                </v-menu>
                            </td>
                        </tr>
                    </template>
                </data-table>
            </v-col>
        </v-row>

        <v-row justify="center">
            <v-dialog
                v-model="dialog"
                persistent
                max-width="300"
            >
                <v-card>
                    <v-card-title class="headline primary white--text">
                        {{ $t('delete_', [$t('warehouse')]) }}
                    </v-card-title>

                    <v-card-text class="pt-2">
                        <p class="mb-2">{{ $t('del_desc_1') }}</p>
                        <p>{{ $t('del_desc_2') }}</p>
                    </v-card-text>

                    <v-card-actions>
                        <v-spacer></v-spacer>

                        <v-btn
                            class="error"
                            color="white"
                            @click="closeDeleteDialog"
                        >
                            {{ $t('no') }}
                        </v-btn>

                        <v-btn
                            class="primary"
                            color="white"
                            :loading="loading"
                            @click="remove"
                        >
                            {{ $t('yes') }}
                        </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </v-row>
    </div>
</template>

<script>
    import DataTable from "../DataTable";
    import VStockStatusSelect from "../VStockStatusSelect";
    import util from "../../../mixins/util"
    import {mapMutations} from "vuex";

    export default {
        name: "Warehouse",
        components: {VStockStatusSelect, DataTable},
        mixins: [ util ],
        data: () => ({
            items: [],
            deleting: null,
            loading: false,
            dialog: false,
        }),

        computed: {
            headers() {
                return [
                    { text: this.$t('country'), value: 'country', sortable: false },
                    { text: this.$t('warehouse_',[this.$t('name')]), value: 'name', sortable: false },
                    { text: this.$t('city'), value: 'city', sortable: false },
                    { text: this.$t('phone'), value: 'phone' },
                    { text: this.$t('fax'), value: 'fax', sortable: false },
                    { text: this.$t('enabled'), value: 'enabled', sortable: false },
                    { text: this.$t('action'), value: 'actions', sortable: false },
                ]
            },

            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('warehouse_',[this.$t('name')])
                });
            },

            statuses() {
                return [
                    { text: this.$t('enabled'), value: 1 },
                    { text: this.$t('disabled'), value: 0 }
                ];
            }
        },

        methods: {
            ...mapMutations('snackbar', [
                'error'
            ]),

            edit(item) {
                this.$router.push({
                    name: 'warehouseEdit',
                    params: {
                        id: item.id
                    }
                })
            },

            openDeleteDialog(item) {
                this.deleting = item;
                this.dialog = true;
            },

            closeDeleteDialog() {
                this.deleting = null;
                this.dialog = false;
            },

            remove() {
                this.loading = true;
                axios.delete('api/warehouses/' + this.deleting.id)
                    .then(({ data }) => {
                        if(data.result === true) {
                            const index = this.items.findIndex(item => item.id === this.deleting.id);
                            this.items.splice(index, 1);
                            this.deleting = null;
                            this.loading = false;
                            this.dialog = false;
                        }
                    })
                    .catch(({ response }) => {
                        this.loading = false;
                        this.dialog = false;
                        this.error(response.data.message);
                    })
            },
        }
    }
</script>

<style scoped>
</style>
